
!ABCIncludeFile

OMIT('_EndOfInclude_',_RangeLimitBrowsePresent_)
_RangeLimitBrowsePresent_ EQUATE(1)

! ---------------------------------------------------------------------------
! AlterRangeBrowseClass,
! Class to allow range limits to altered at run time.
!
! Written by Dennis E. Evans
! compiler  CW5b
! date  23 Jul 00
!
! send questions or comments to evansd@midwest.net
! ---------------------------------------------------------------------------

  INCLUDE ('AbBrowse.inc'),once
  include('Keycodes.clw'),once

AlterRangeBrowseClass CLASS(BrowseClass)TYPE,MODULE('AlBrw.clw'),LINK('AlBrw.clw',_ABCLinkMode_),DLL(_ABCDllMode_)
ClearRangeControl       unsigned,private    ! control used to clear the range limit
ClearRangeCode          long,private        ! key code to clear range limit
SelectListOnReset       byte,private        ! flag to indicate to select list box, true select list
RangeLimitCondition     string(1),private   ! use single limit of =, >=, or <=
! ----------------------
! class methods
! ---------------------
Init                    PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)
! init and set defaults
SetRangeControl         procedure(unsigned ClearControl) ! assign control
! set the control to clear the limit
SetSelectList           procedure(byte OnOff = true)
! select list box on reset actions
SetClearCode            procedure(long K = CtrlR)   ! default code
! set key code used to clear range limit
SetRangeCondition       procedure(string Cond)
! set the condition for the range limit
GetRangeCondition       procedure(),string
! get the current range limit condition
RangelimitActive        procedure(),byte
! ---------------------
! virtual methods
! --------------------
! reset the range limit based on the para passed
ResetRangeLimit         procedure(),virtual     ! clears range limit
ResetRangeLimit         procedure(*? FieldName),virtual ! current type limit
ResetRangeLimit         procedure(*? FieldName, *? StartField),virtual ! single type limit
ResetRangeLimit         procedure(*? FieldName, *? StartField, *? StopField),virtual ! range type limit
! -----------------
! derived methods
! ----------------
ApplyFilter             PROCEDURE,VIRTUAL
! calls parent for default if RangeLimitCondition is '='
TakeEvent               PROCEDURE,VIRTUAL
TakeKey                 PROCEDURE,BYTE,PROC,VIRTUAL 
GetFreeElementPosition  PROCEDURE,BYTE,PROTECTED,VIRTUAL
UpdateWindow            PROCEDURE,VIRTUAL
! -----------------------------
! private methods
! -----------------------------
ResetRange              procedure(byte LimitType = Limit:None),private
! reset range limit, called by other methods, assigns limit type and calls ResetSort
AdjustSingleFilter      procedure(),private
! adjust single and current range types
AdjustPairFilter        procedure(),private
! adjust range of values type
AddFilterCriteria       procedure(*cstring Rf),private
! adds the current filter criteria to the view filter, after the range limits
                      end ! class

_EndOfInclude_
